% 8 avril 2020
% verson 0.3
/internalgears {
50 dict begin
/a@in m Z1 Z2 sub mul 2 div def % entraxe engrenage interieur
/Pi 3.14159265359 def
/rad2deg { 180 mul Pi div } bind def 		% convert from radian to degrees
/deg2rad { Pi mul 180 div } bind def 		% viceversaf
lowresolution {/d2 2 def /dt 0.5 def /dth 5 def}{/d2 0.5 def /dt 0.1 def /dth 1 def} ifelse
/Datas2 { % pour l'engrenage intrieur
         /Z@ exch def
         /m@ exch def
         /R@ {m@ Z@ mul 2 div } bind def % cercle primitif
         /Rb {R@ ap cos mul } bind def % cercle de base
         /Rt {R@ 2 mul 2.5 m@ mul add 2 div d@ add } bind def % cercle de tte
         /Rp {R@ 2 mul 2 m@ mul sub 2 div d@ add } bind def % cercle de pied
         } def
/Datas1 { % pour l'engrenage extrieur
         /Z@ exch def
         /m@ exch def
         /R@ {m@ Z@ mul 2 div } bind def % cercle primitif (Pitch radius)
         /Rb {R@ ap cos mul } bind def % cercle de base
         /Rt {R@ 2 mul 2 m@ mul add 2 div } bind def % cercle de tte
         /Rp {R@ 2 mul 2.5 m@ mul sub 2 div } bind def % cercle de pied
         } def
/Calculs {
         R@ 1 ge { % vis
                 /rScrew R@ 10 div def
                 }{
                 /rScrew R@ 5 div def
                 } ifelse
         % les valeurs suivantes sont en radians
         /ThetaP {R@ Rb div dup mul 1 sub abs sqrt } bind def % intersection avec cercle primitif
         /ThetaT {Rt Rb div dup mul 1 sub abs sqrt } bind def % intersection avec cercle de tete
         % Les valeurs suivantes ont en degrs
         /ThetaTdeg {Rt Rb div dup mul 1 sub abs sqrt rad2deg } bind def %
         /ThetaPdeg {R@ Rb div dup mul 1 sub abs sqrt rad2deg } bind def
         /ThetaPdeg {R@ Rb div dup mul 1 sub abs sqrt rad2deg } bind def
         /ThetaPieddeg {Rp Rb div dup mul 1 sub abs sqrt rad2deg } bind def
         /DeltaP {ThetaPdeg sin ThetaP ThetaPdeg cos mul sub
                  ThetaPdeg cos ThetaP ThetaPdeg sin mul add
                  atan } bind def
         /DeltaT {ThetaTdeg sin ThetaT ThetaTdeg cos mul sub
                  ThetaTdeg cos ThetaT ThetaTdeg sin mul add
                  atan } bind def
         /DeltaS {Pi 2 div Z@ div } bind def
         /DeltaSdeg {90 Z@ div } bind def
         /AngleDent {360 Z@ div} bind def
         /Alpha {DeltaSdeg DeltaP add DeltaT sub } bind def
         /2Beta {DeltaSdeg DeltaP add 2 mul } bind def
         /Beta_  {DeltaSdeg DeltaP add neg} bind def
         /ptA {Rp 0} bind def
         /ptB {Rb 0} bind def
         /ptC {Rp DeltaSdeg 2 mul neg 2Beta 2 div add cos mul
               Rp DeltaSdeg 2 mul neg 2Beta 2 div add sin mul} bind def
         /ptA'{Rp DeltaP DeltaSdeg add 2 mul cos mul
               Rp DeltaP DeltaSdeg add 2 mul sin mul} bind def
         /ptB'{Rb DeltaP DeltaSdeg add 2 mul cos mul
               Rb DeltaP DeltaSdeg add 2 mul sin mul} bind def
         /ptC'{Rp DeltaSdeg 3 mul DeltaP add cos mul
               Rp DeltaSdeg 3 mul DeltaP add sin mul} bind def
         /Raxe {Rp 4 div } bind def
% rayon de raccordement sur le cercle de pied
         /Rarct {Rp Pi mul Z@ div 12 div cm} bind def
         }
         def
% Le symetrique P' de P par rapport a la l'axe de la dent
% Delta(axe de la dent) y=x*tan(Beta)
% x'=y*sin(2*Beta)+x*cos(2*Beta)
% y'=x*sin(2*Beta)-y*cos(2*Beta)
% x y symAxe -> x' y'
/symAxe {
 2 dict begin
  /y exch def
  /x exch def
  y 2Beta sin mul x 2Beta cos mul add % x'
  x 2Beta sin mul y 2Beta cos mul sub % y'
 end
 }
 def
% Rotation pour amener l'axe de la dent horizontal
%
/RotDent {
 2 dict begin
/y exch def
/x exch def
 i@ cos x mul i@ sin y mul sub
 i@ sin x mul i@ cos y mul add
end
} def
%
/RotRoueInt {
 2 dict begin
/y exch def
/x exch def
 polarAngle cos x mul polarAngle sin y mul sub
 polarAngle sin x mul polarAngle cos y mul add
end
} def
% developpante du cercle de base
%
 /devCercle {
  1 dict begin
  /t exch def % en degres
  Rb t cos t deg2rad t sin mul add mul % x
  Rb t sin t deg2rad t cos mul sub mul % y
 end
 }
 def
/SF { % 
   %% tableau des sommets
   /S [
      0 1 N {
         /j exch def
         0 1 n {
             /i exch def
             table i getp
             z0
             z1 z0 sub N j sub N div mul add
         } for
      } for
   ] def
   /F [
%% on conserve la face 0 ?
     [1 1 n {} for] -1 rollparray
%%   on conserve la face 1
      [N 1 add n 1 add mul 1 sub -1 N n 1 add mul {} for] -1 rollparray
      %% faces etage
      1 1 N {
         /j exch def
         1 1 n {
             /i exch def
             [i                   j 1 sub n 1 add mul add
              i 1 sub             j 1 sub n 1 add mul add
              n 1 add i add 1 sub j 1 sub n 1 add mul add
              n 1 add i add       j 1 sub n 1 add mul add]
         } for
     } for
   ] def
   S F generesolid
} def
%%%% definition des roues dentees %%%%%%
% trac de la roue
%%% Les dessins de l'engrenage %%%%%%
%%%%%%%%%% Roue N2 %%%%%%%%%%%%%%%%%
% roue interne
m Z2
    Datas2
    Calculs
/tabArcDev [
ThetaPieddeg 1 ThetaTdeg { /i@ exch def
 [i@ devCercle] } for
  [ThetaTdeg devCercle]
 ] def
%
/n@ tabArcDev length def
%
/tabDent [
% l'arc de developpante initial
  tabArcDev aload pop
% l'arc ce cercle de tete
DeltaT 0.1 2Beta DeltaT sub {/i@ exch def
 [Rt i@ cos mul
  Rt i@ sin mul]
 } for
 [Rt 2Beta DeltaT sub cos mul Rt 2Beta DeltaT sub sin mul]
% le symetrique de l'arc de developpante par rapport a l'axe de la dent
n@ 1 sub -1 0  {
    /compteur exch def
    [tabArcDev compteur get aload pop symAxe]
    } for
    ] def
/tabDentIn tabDent reversep def
%
/Rc Rt 1.25 mul def % rayon de la couronne
/ptA1 { % le point sur la couronne sur le rayon de A
Rc 0
} def
% rotation d'un point d'un angle gal  celui d'une dent
/RotationDent {
 2 dict begin
/y exch def
/x exch def
 AngleDent cos x mul AngleDent sin y mul sub
 AngleDent sin x mul AngleDent cos y mul add
end
} def
%
/ptA'2 { % l'image de A dans la rotation d'un angle gal  celui d'une dent
ptA RotationDent
} def
/ptA3 {
 ptA SymAxe
} def
% point de la couronne sur ce rayon
ptA'2 /yA2 exch def /xA2 exch def
yA2 xA2 atan /angle2 exch def
% trac de la dent
/n2@ tabDentIn length def
%
[
ptA
0 d2 angle2 {/i exch def
 Rc i cos mul
 Rc i sin mul
 } for
 Rc angle2 cos mul
 Rc angle2 sin mul
 ptA'2
 ptA'
0 1 n2@ 1 sub {
    /compteur exch def
    tabDentIn compteur get aload pop
   } for
ptA
] /ContourInternalGears exch def %
%%%%%%%%%%%%%%%%
    0 wheelwidth % hauteur =z1-z0
   /z1 exch def
   /z0 exch def
   %% N = nb d etages
   /N ngrid 0 get def
   /table ContourInternalGears  def
   %% n = indice du dernier point
   /n  ContourInternalGears length 2 idiv 1 sub def
   SF
%  dup (fillincolor) outputcolors
  /unedent3d exch def
   unedent3d
  Z@  {
   unedent3d { 0 0 AngleDent rotateOpoint3d} solidtransform
   /unedent3d exch def
   unedent3d
solidfuz
    } repeat
 { 0 0 AngleRotation rotateOpoint3d} solidtransform
 /RoueInt exch def
% pour dessiner la face de la roue interne
ZpointVue 0 ge {/zdraw z1 def}{/zdraw z0 def} ifelse
ContourInternalGears
    /table exch def
   /n table length 2 idiv def
   /S [
  0 1 n 1 sub {/i exch def
    table i getp
    zdraw
    } for
     ] def
   /F [
       [0 1 n 1 sub {} for] ZpointVue 0 le {decal rollparray reverse} if
   ] def
   S F generesolid
   dup (fillincolor) outputcolors
   /unedent exch def
   unedent
   Z@ {
   unedent { 0 0 AngleDent  rotateOpoint3d} solidtransform
   /unedent exch def
   unedent
   solidfuz
    } repeat
   { 0 0 AngleRotation rotateOpoint3d} solidtransform
/FaceAvantRoueInterne exch def
%      drawsolid**
/ContourInterne [
0 1 Z@ 1 sub {/i@ exch AngleDent mul def
% roue intrieure
ptC RotDent
ptA RotDent
0 1 n2@ 1 sub {
    /compteur exch def
    tabDent compteur get aload pop
    RotDent } for
ptA' RotDent ptC' RotDent
}for
] def
%
ContourInterne reversep
    /table exch  def
   /n table length 2 idiv def
   /S [
  0 1 n 1 sub {/i exch def
    table i getp % neg
    zdraw
    } for
     ] def
   /F [
       [0 1 n 1 sub {} for]  decal rollparray
   ] def
   S F generesolid
 {0 0 AngleRotation rotateOpoint3d} solidtransform
/ContourRoueInt exch def
% pour la roue  denture extrieure
% celle  l'intrieur
/Roue2D {
 % arc de dveloppante
/tabArcDev [
0 dth ThetaTdeg { /i@ exch def
 [i@ devCercle] } for
 ] def
 %
/n@ tabArcDev length def
/tabDent [
% l'arc de developpante initial
  tabArcDev aload pop
% l'arc ce cercle de tete
DeltaT dt 2Beta DeltaT sub {/i exch def
 [Rt i cos mul
  Rt i sin mul]
 } for
% le symetrique de l'arc de developpante par rapport a l'axe de la dent
n@ 1 sub -1 0  {
    /compteur exch def
    [tabArcDev compteur get aload pop symAxe]
    } for
    ] def
%%%
/n2@ tabDent length def
/ContourDent2D  [
ptC
0 1 Z@ 1 sub {/i@ exch AngleDent mul def
ptC RotDent
ptA RotDent
0 1 n2@ 1 sub {
    /compteur exch def
    tabDent compteur get aload pop
    RotDent
    } for
ptA' RotDent
ptC' RotDent
} for
] def
% petite roue  denture extrieure
    0 wheelwidth % hauteur =z1-z0
   /z1 exch def
   /z0 exch def
   %% N = nb d etages
   /N ngrid 0 get def
   /table ContourDent2D def
   %% n = indice du dernier point
   /n  ContourDent2D length 2 idiv 1 sub def
   %% vecteur de translation
   %% tableau des sommets
   SF
   /Roue3D exch def
  ContourDent2D
    /table exch def
   /n table length 2 idiv def
   /S [
  0 1 n 1 sub {/i exch def
    table i getp
    z1
    } for
     ] def
   /F [
       [1 1 n 1 sub {} for] decal rollparray
   ] def
   S F generesolid
      dup videsolid
   /ContourSup exch def
   } def
m Z1
    Datas1
    Calculs
Roue2D
Roue3D
   {0 0 adjustangle DeltaP add AngleRotation Z2 Z1 div mul add rotateOpoint3d} solidtransform
   dup {a@in neg 0 0 translatepoint3d} solidtransform
    dup (fillincolor) outputcolors
 RoueInt
 solidfuz
% /solidgrid false def
    gere_pstricks_opt
ContourSup
  {0 0 adjustangle DeltaP add AngleRotation Z2 Z1 div mul add rotateOpoint3d} solidtransform
  {a@in neg 0 0 translatepoint3d} solidtransform
% pour supprimer les contours de la face sup de la roue  denture externe faire
% /solidgrid false def
linecolor
       /solidgrid true def
dup (fillincolor) outputcolors
   drawsolid**
% pour supprimer les contours de la face sup de la roue  denture interne faire
% /solidgrid false def
   /solidgrid true def
FaceAvantRoueInterne
drawsolid**
ContourRoueInt
 drawsolid
/circumference [
0 1 360 {/i exch def
    i cos Rc mul i sin Rc mul
    } for
] def
circumference
    /table exch  def
   /n table length 2 idiv def
   /S [
  0 1 n 1 sub {/i exch def
    table i getp % neg
    zdraw
    } for
     ] def
   /F [
       [0 1 n 1 sub {} for]  -1 rollparray
   ] def
   S F generesolid
    drawsolid
% un point sur la grande roue
/UnPoint [
0 1 360 {/i exch def
    i cos 0.5 mul Rc 0.9 mul add neg
    i sin 0.5 mul
    } for
] def
UnPoint
    /table exch reversep def
   /n table length 2 idiv def
   /S [
  0 1 n 1 sub {/i exch def
    table i getp
    zdraw
    } for
     ] def
   /F [
       [0 1 n 1 sub {} for]
   ] def
   S F generesolid
    {0 0 AngleRotation rotateOpoint3d} solidtransform
    dup (0 setgray) outputcolors
    drawsolid**
end
   } def
/pst-internalgear {
   internalgears
  }
  def
